<?php

function theme_customize_login() { 
?>
    <link rel="stylesheet" href="<?php echo get_bloginfo( 'stylesheet_directory' ) . '/login.css'; ?>" type="text/css" media="all" />
<?php 
}
add_action( 'login_enqueue_scripts', 'theme_customize_login' );

function theme_add_post_title_to_blog_title($title, $sep) {
    if( is_single() ) {
        global $post;
        $title = $post->post_title . ' | ' . get_bloginfo( 'name' );
    }
    return $title;
}

add_filter('wp_title', 'theme_add_post_title_to_blog_title', 10, 2);

function theme_flush_rewrite() {
    flush_rewrite_rules();
}
add_action( 'after_switch_theme', 'theme_flush_rewrite' );


function theme_show_on_match() {  
    if (is_search()) {  
        global $wp_query;  
        if ($wp_query->post_count == 1) {  
            wp_redirect( get_permalink( $wp_query->posts['0']->ID ) );  
        }  
    }  
}
add_action('template_redirect', 'theme_show_on_match');  

function theme_title_only_search( $search, &$wp_query ) {  
    global $wpdb;
    
    if ( empty($search) )  
        return $search; // skip processing - no search term in query  
    
    $search = '';
    
    $q = $wp_query->query_vars;
    
    // Fill again in case pre_get_posts unset some vars.
    $q = $wp_query->fill_query_vars($q);
    
    if ( isset($q) && !empty($q['s']) ) {
        // added slashes screw with quote grouping when done early, so done later
        $q['s'] = stripslashes($q['s']);
        if ( empty( $_GET['s'] ) && $wp_query->is_main_query() )
            $q['s'] = urldecode($q['s']);
        if ( !empty($q['sentence']) ) {
            $q['search_terms'] = array($q['s']);
        } else {
            preg_match_all('/".*?("|$)|((?<=[\r\n\t ",+])|^)[^\r\n\t ",+]+/', $q['s'], $matches);
            $q['search_terms'] = array_map('_search_terms_tidy', $matches[0]);
        }
        $n = !empty($q['exact']) ? '' : '%';
        $searchand = '';
        foreach( (array) $q['search_terms'] as $term ) {
            $term = esc_sql( like_escape( $term ) );
            $search .= "{$searchand}($wpdb->posts.post_title LIKE '{$n}{$term}{$n}')";
            $searchand = ' AND ';
        }

        if ( !empty($search) ) {
            $search = " AND ({$search}) ";
            if ( !is_user_logged_in() )
                $search .= " AND ($wpdb->posts.post_password = '') ";
        }
    }
    return $search;
}  
add_filter( 'posts_search', 'custom_search', 10, 2 );

?>